'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Validation = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Observable = require('rxjs/Observable');

var _ValidationIteration = require('./ValidationIteration');

var _Validators = require('./Validators');

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Validation = exports.Validation = function () {
    _createClass(Validation, [{
        key: 'validationSchema',

        /**
         * @var { required: boolean, type?: {} }
         */
        get: function get() {
            return this._validationSchema || {};
        },
        set: function set(value) {
            this._validationSchema = value;
        }

        /** 
         * @var Array<Observable<ValidationResults>>
         */

    }, {
        key: 'validationIterations',
        get: function get() {
            return this._validationIterations || [];
        },
        set: function set(value) {
            this._validationIterations = value;
        }
    }]);

    function Validation() {
        var validationSchema = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        _classCallCheck(this, Validation);

        this.validationSchema = validationSchema;
    }

    _createClass(Validation, [{
        key: 'createRequiredValidator',
        value: function createRequiredValidator(data, reqValidationConfig) {
            var requiredConfig = typeof reqValidationConfig === 'boolean' ? { required: reqValidationConfig, message: 'Field is required.' } : reqValidationConfig;
            return new _Validators.RequiredValue(data, requiredConfig);
        }
    }, {
        key: 'createValidators',
        value: function createValidators(dataMap, validationConfig, fieldname) {
            if (!validationConfig) return [];
            var validators = [];
            if (validationConfig.required) {
                var requiredValidator = this.createRequiredValidator(dataMap[fieldname], validationConfig.required, fieldname);
                validators = [].concat(_toConsumableArray(validators), [requiredValidator]);
            }
            if (validationConfig.type) {
                validators = [].concat(_toConsumableArray(validators), [new validationConfig.type(dataMap, validationConfig, fieldname)]);
            }
            return validators;
        }
    }, {
        key: 'validate',
        value: function validate(dataMap) {
            var _this = this;

            var observable$ = new _Observable.Observable(function (observer) {
                var keys = Object.keys(dataMap);
                keys.forEach(function (key) {
                    var validationConfig = _this.validationSchema[key];
                    var validators = _this.createValidators(dataMap, validationConfig, key);
                    var _validationIteration = new _ValidationIteration.ValidationIteration(validators, key, function (validationResult) {
                        observer.next(validationResult);
                    });
                    _this.validationIterations = [].concat(_toConsumableArray(_this.validationIterations), [_validationIteration]);
                    _validationIteration.doValidate();
                });
                return function () {
                    _this.validationIterations.forEach(function (validationIteration) {
                        validationIteration.cleanup();
                    });
                    _this.validationIterations = [];
                };
            });

            return observable$;
        }
    }]);

    return Validation;
}();