'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.ValidationIteration = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ValidationResult = require('./ValidationResult');

var _Observable = require('rxjs/Observable');

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ValidationIteration = exports.ValidationIteration = function () {
    _createClass(ValidationIteration, [{
        key: 'validators',

        /**
         * Validator 
         */
        get: function get() {
            return this._validators;
        },
        set: function set(value) {
            this._validators = value;
        }
    }, {
        key: 'counter',
        get: function get() {
            return this._counter || 0;
        },
        set: function set(value) {
            this._counter = value;
        }
    }]);

    function ValidationIteration(validators, fieldname, callback) {
        _classCallCheck(this, ValidationIteration);

        this.validators = validators;
        this.callback = callback;
        this.validationResult = new _ValidationResult.ValidationResult();
        this.validationResult.fieldname = fieldname;
    }

    _createClass(ValidationIteration, [{
        key: 'handler',
        value: function handler(response) {
            if (response) {
                this.validationResult.errors = [].concat(_toConsumableArray(this.validationResult.errors), [response.message]);
            }
            this.counter = this.counter + 1;
            if (this.validators.length === this.counter) {
                this.callback(this.validationResult);
            }
        }
    }, {
        key: 'doValidate',
        value: function doValidate() {
            var _this = this;

            if (this.validators.length === 0) {
                this.callback(this.validationResult);
            }
            this.validators.forEach(function (validator) {
                var value = validator.doValidation();
                if (value && value.constructor.name === 'Promise') {
                    value.then(_this.handler.bind(_this));
                } else if (value && value.constructor.name === 'Observable') {
                    value.subscribe(_this.handler.bind(_this));
                } else {
                    _this.handler(value);
                }
            });
        }
    }, {
        key: 'cleanup',
        value: function cleanup() {
            this.validators.forEach(function (validator) {
                validator.cleanup();
            });
        }
    }]);

    return ValidationIteration;
}();