'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.AsyncValue = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Validator2 = require('./Validator');

var _Observable = require('rxjs/Observable');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AsyncValue = exports.AsyncValue = function (_Validator) {
    _inherits(AsyncValue, _Validator);

    _createClass(AsyncValue, [{
        key: 'configSchemaCheck',
        value: function configSchemaCheck() {
            if (typeof this.config.asyncFunction !== 'function') {
                throw new Error('must define an asyncFunction for type AsyncValue validator.');
            }
            if (typeof this.config.cleanup !== 'function') {
                throw new Error('must define an cleanup function for type AyncValue validator.');
            }
        }
    }, {
        key: 'resultSchemaCheck',
        value: function resultSchemaCheck(data) {
            if (data !== null && ((typeof data === 'undefined' ? 'undefined' : _typeof(data)) !== 'object' || !data.message)) {
                throw new Error('Must return an object with message defined or null.');
            }
        }
    }, {
        key: 'data',
        get: function get() {
            return this._data;
        },
        set: function set(value) {
            this._data = value;
        }
    }, {
        key: 'config',
        get: function get() {
            return this._config;
        },
        set: function set(value) {
            this._config = value;
        }
    }]);

    function AsyncValue(dataList, config, fieldname) {
        _classCallCheck(this, AsyncValue);

        var _this = _possibleConstructorReturn(this, (AsyncValue.__proto__ || Object.getPrototypeOf(AsyncValue)).call(this));

        _this.data = dataList[fieldname];
        _this.config = config;
        _this.configSchemaCheck();
        return _this;
    }

    _createClass(AsyncValue, [{
        key: 'doValidation',
        value: function doValidation() {
            var _this2 = this;

            return new _Observable.Observable(function (observer) {
                var next = observer.next;
                _this2.config.asyncFunction(_this2.data, function (data) {
                    _this2.resultSchemaCheck(data);
                    observer.next(data);
                });
                return _this2.config.cleanup;
            });
        }
    }, {
        key: 'cleanup',
        value: function cleanup() {
            this.config.cleanup();
        }
    }]);

    return AsyncValue;
}(_Validator2.Validator);