'use strict';

var assert = require('assert');
var AsyncValue = require('./AsyncValue').AsyncValue;
var fieldname = 'name';
describe('AsyncValidator', function () {
    var validator = new AsyncValue('yella', {
        type: AsyncValue,
        asyncFunction: function asyncFunction(data, next) {
            setTimeout(function () {
                next(null);
            }, 100);
        },
        cleanup: function cleanup() {}
    }, fieldname);

    it('constructing an Async Validator with no asyncFunctin or cleanup on config', function () {
        try {
            var failValidator = new AsyncValue('yella', { type: AsyncValue }, 'name');
        } catch (e) {
            assert.equal(e.constructor.name, 'Error');
        }
    });

    it('doValidation called with null next should', function (done) {
        var observable$ = validator.doValidation();
        assert.equal(observable$.constructor.name, 'Observable', 'return Observable');

        observable$.subscribe(function (response) {
            assert.equal(response, null, 'result in null');
            done();
        });
    });
});