'use strict';

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var assert = require('assert');
var DateValue = require('./DateValue').DateValue;

var fieldname = 'date';
describe('DateValueValidator', function () {
    var validDateList = ['12/12/2017', '12 Jan 2017'];

    validDateList.forEach(function (validDate) {
        it('given valid date', function () {
            var validator = new DateValue(_defineProperty({}, fieldname, validDate), { type: DateValue }, fieldname);
            var value = validator.doValidation();
            assert.equal(value, null, 'should be null');
        });
    });

    it('given invalid date', function () {
        var validator = new DateValue({ date: '121/12/2017' }, { type: DateValue }, fieldname);
        var value = validator.doValidation();
        assert.equal(!!(value && value.message), true, 'should be invalid');
    });
});