'use strict';

var assert = require('assert');
var RequiredValue = require('./RequiredValue').RequiredValue;

describe('RequiredValidator', function () {
    it('doValidation should return null', function () {
        var validator = new RequiredValue('somethings', {
            required: true
        });
        assert.equal(validator.doValidation(), null, 'should validate and return null');
    });

    it('doValidation should return error with ""', function () {
        var validator = new RequiredValue('', {
            required: true
        });
        var x = validator.doValidation();
        assert.equal(!!x && !!x.message, true);
    });

    it('doValidation should return error with undefined', function () {
        var validator = new RequiredValue(undefined, {
            required: true
        });
        var x = validator.doValidation();
        assert.equal(!!x && !!x.message, true);
    });

    it('doValidation should return error with null', function () {
        var validator = new RequiredValue(null, {
            required: true
        });
        var x = validator.doValidation();
        assert.equal(!!x && !!x.message, true);
    });

    it('doValidation should return null with 0', function () {
        var validator = new RequiredValue(0, {
            required: true
        });
        assert.equal(validator.doValidation(), null, 'should validate and return null');
    });

    it('doValidation should return null invalid value and required: false', function () {
        var validator = new RequiredValue(undefined, {
            required: false
        });
        assert.equal(validator.doValidation(), null, 'should validate and return null');
    });
});